package be.iminds.ilabt.jfed.experimenter_gui.timeline.controller.action;

import be.iminds.ilabt.jfed.experimenter_gui.timeline.model.TimelineModel;
import be.iminds.ilabt.jfed.experimenter_gui.timeline.view.TimelineComponent;
import be.iminds.ilabt.jfed.experimenter_gui.timeline.view.UpdateEvent;
import be.iminds.ilabt.jfed.rspec.model.controller.ExperimentCommand;

import javax.annotation.Nonnull;

/**
 * @author Cedric
 */
public class DeleteCommandAction implements IAction {
    @Nonnull private final ExperimentCommand command;

    public DeleteCommandAction(@Nonnull ExperimentCommand command) {
        this.command = command;
    }

    @Override
    public boolean execute(@Nonnull TimelineModel model, @Nonnull TimelineComponent view) {
        //can't remove a command that's already started execution
        if (command.isStarted())
            return false;

        model.deleteCommand(command);
        view.update(UpdateEvent.DELETE_COMMAND, command);
        return true;
    }

    @Override
    public boolean undo(@Nonnull TimelineModel model, @Nonnull TimelineComponent view) {
        //Can't add if the starting time is already in the past
        if (model.getElapsedTime() > command.getStartingTime().toMillis())
            return false;

        model.addCommand(command);
        view.update(UpdateEvent.ADD_COMMAND, command);
        return true;
    }
}
